public class Printing extends GGen
{
    GCircle dots[10];
    FlatMaterial mdot, mspecial, mp;
    // @(1.0, 0.753, 0.796) => vec3 specialColor;
    // @(0.95, 0.40, 0.52) => vec3 specialColor;
    @(0.9, 0.74, 0.3) => vec3 specialColor;
    @(0.45, 0.42, 0.36) * 0.5 => vec3 dotColor;
    // @(0.588, 0.356, 0.596) => vec3 dotColor;

    mdot.color(dotColor);
    mspecial.color(specialColor);
    mp.color(dotColor);

    GPlane p1, p2, p3, p4;
    p1.mat(mp);
    p2.mat(mp);
    p3.mat(mp);
    p4.mat(mp);

    for(int i; i < 10; i++)
    {
        // dots[i].mat(mat);
        dots[i].mat(mdot);
        dots[i].sca(0.5);
    }
    
    fun void init(int digit, GGen @ parent)
    {
        
        this --> parent;
        this.sca(0.15);
        if ( (digit < 0) || (digit > 15))
        {
            <<<"Invalid Digit">>>;
        }
        else if ( digit == 0)
        {
            
            dots[0] --> this;
            dots[0].sca(0.8);
            dots[0].mat(mspecial);

            dots[1] --> this;
            dots[1].sca(0.5);
            dots[1].mat(mdot);
        }
        else if( digit == 1 )
        {
            dots[0] --> this;
            dots[0].mat(mspecial);
        }
        else if( digit == 2 )
        {
            dots[0] --> this;
            dots[0].pos( @(0, 1, 0) );

            dots[1] --> this;
            dots[1].mat(mspecial);
            dots[1].pos( @(0, -1, 0) );
        }
        else if( digit == 3 )
        {
            dots[0] --> this;
            dots[0].pos( @(-1, 1, 0) );

            dots[1] --> this;
            dots[1].mat(mspecial);
            dots[1].pos( @(0, 0, 0) );

            dots[2] --> this;
            dots[2].pos( @(1, -1, 0) );
        }

        else if( digit == 4 )
        {
            1 => float d;
            dots[0] --> this;
            dots[0].pos( @(-d, d, 0) );

            dots[1] --> this;
            dots[1].pos( @(d, d, 0) );

            dots[2] --> this;
            dots[2].pos( @(-d, -d, 0) );

            dots[3] --> this;
            dots[3].pos( @(d, -d, 0) );
        }

        else if( digit == 5 )
        {
            1 => float d;
            dots[0] --> this;
            dots[0].pos( @(-d, d, 0) );

            dots[1] --> this;
            dots[1].pos( @(d, d, 0) );

            dots[2] --> this;
            dots[2].pos( @(-d, -d, 0) );

            dots[3] --> this;
            dots[3].pos( @(d, -d, 0) );

            dots[4] --> this;
            dots[4].pos( @(0, 0, 0) );
            dots[4].mat(mspecial);
        }

        else if( digit == 6 )
        {
            1 => float d;
            0.1 => float pad;
            dots[0] --> this;
            dots[0].pos( @(-d/2, (d + pad) * 1.5, 0) );

            dots[1] --> this;
            dots[1].pos( @(d/2, (d + pad) * 1.5, 0) );

            dots[2] --> this;
            dots[2].pos( @(-d/2, (d + pad) / 2, 0) );

            dots[3] --> this;
            dots[3].pos( @(d/2, (d + pad) / 2, 0) );

            dots[4] --> this;
            dots[4].pos( @(-d/2, -(d + pad) * 1.5, 0) );

            dots[5] --> this;
            dots[5].pos( @(d/2, -(d + pad) * 1.5, 0) );
        }

        
        else if( digit == 7 )
        {
            1 => float d;
            0.1 => float pad;
            dots[0] --> this;
            dots[0].pos( @(-d/2, (d + pad) * 1.5, 0) );

            dots[1] --> this;
            dots[1].pos( @(d/2, (d + pad) * 1.5, 0) );

            dots[2] --> this;
            dots[2].pos( @(-d/2, (d + pad) / 2, 0) );

            dots[3] --> this;
            dots[3].pos( @(d/2, (d + pad) / 2, 0) );

            dots[4] --> this;
            dots[4].pos( @(-d, -(d + pad) * 1.5, 0) );

            dots[5] --> this;
            dots[5].pos( @(d, -(d + pad) / 2, 0) );

            dots[6] --> this;
            dots[6].pos( @(0, -d, 0) );
            dots[6].mat(mspecial);
        }
        
        else if( digit == 8 )
        {
            1 => float d;
            0.1 => float pad;
            dots[0] --> this;
            dots[0].pos( @(-d/2, (d + pad) * 1.5, 0) );

            dots[1] --> this;
            dots[1].pos( @(d/2, (d + pad) * 1.5, 0) );

            dots[2] --> this;
            dots[2].pos( @(-d/2, (d + pad) / 2, 0) );

            dots[3] --> this;
            dots[3].pos( @(d/2, (d + pad) / 2, 0) );

            dots[4] --> this;
            dots[4].pos( @(-d/2, -(d + pad) / 2, 0) );

            dots[5] --> this;
            dots[5].pos( @(d/2, -(d + pad) / 2, 0) );


            dots[6] --> this;
            dots[6].pos( @(-d/2, -(d + pad) * 1.5, 0) );

            dots[7] --> this;
            dots[7].pos( @(d/2, -(d + pad) * 1.5, 0) );


        }

        else if( digit == 9 )
        {
            1.2 => float d;
            dots[0] --> this;
            dots[0].pos( @(-d, d, 0) );

            dots[1] --> this;
            dots[1].pos( @(0, d, 0) );

            dots[2] --> this;
            dots[2].pos( @(d, d, 0) );

            dots[3] --> this;
            dots[3].pos( @(-d, 0, 0) );

            dots[4] --> this;
            dots[4].pos( @(0, 0, 0) );
            dots[4].mat(mspecial);

            dots[5] --> this;
            dots[5].pos( @(d, 0, 0) );

            dots[6] --> this;
            dots[6].pos( @(-d, -d, 0) );

            dots[7] --> this;
            dots[7].pos( @(0, -d, 0) );

            dots[8] --> this;
            dots[8].pos( @(d, -d, 0) );
        }

        else if( digit == 10 )
        {
            
            p1 --> this;
            p2 --> this;

            p1.sca(@(2, 0.5, 0));
            p2.sca(@(2, 0.5, 0));

            p1.pos(@(0, 0.5, 0));
            p2.pos(@(0, -0.5, 0));
        }

        else if( digit == 11 )
        {
            
            p1 --> this;
            p2 --> this;

            p1.sca(@(2, 0.5, 0));
            p2.sca(@(0.5, 2, 0));

            // p1.pos(@(-1, 0, 0))
            // p2.pos(@(-1, 0, 0))
        }

        else if( digit == 12 )
        {
            
            p1 --> this;
            // p2 --> this;

            p1.sca(@(2, .5, 0));
            // p2.sca(@(2, 1, 0))

        }

        else if( digit == 13 )
        {
            p1 --> this;
            p2 --> this;
            p3 --> this;

            p1.sca(@(2, .5, 0));
            p2.sca(@(2, .5, 0));
            p3.sca(@(.5, 1, 0));

            
            p1.pos(@(0, 0.5, 0));
            p2.pos(@(0, -0.5, 0));
            p3.pos(@(-1, 0, 0));
        }

        
        else if( digit == 14 )
        {
            p1 --> this;
            p1.sca(@(2, 2, 0));

        }
    }
}